import processing.video.*;

// Class Code Set 20



// From Daniel Shiffman's Processing - Chaper 16

// Modified for Processing 2.0

Capture video;

int x, y, dX, dY;
int pointillize;

void setup()
{
   size( 1280, 720 );
   
      String[] cameras = Capture.list();
  
  if (cameras.length == 0) 
  {
    println("There are no cameras available for capture.");
    exit();
  } else 
  {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) 
    {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    video = new Capture(this, cameras[0]);
    video.start();  
  }
   
   
   
   noStroke( );
   
   pointillize = 16;
}

void draw( )
{
   //background( 0 );
   
  if( video.available( )  )
  {
     video.read( );
  
    int x = int( random(width ) );
    int y = int( random(height) );
    int loc = x + y*width;
    
    //loadPixels( );
    float r = red( video.pixels[loc] );
    float g = green( video.pixels[loc] );
    float b = blue( video.pixels[loc] );
    fill( r, g, b, 100 );
   
    image( video, width/2, 0, 128, 72);
    ellipse( x, y, pointillize, pointillize );
  }
}
