import processing.video.*;

// Class Code Set 21
// From Daniel Shiffman's Processing - Chaper 16

// This tracks a color.
// Click on a colored object iin the frame that you can move


Capture video;

color targetColor, currentColor;

float worldRecord, r1, r2, r3, g1, g2, g3, b1, b2, b3, d;
float threshold = 50000;
int closestX, closestY, loc;

void setup()
{
   size( 620, 480 );
  
    String[] cameras = Capture.list();
  
  if (cameras.length == 0) 
  {
    println("There are no cameras available for capture.");
    exit();
  } else 
  {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) 
    {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    video = new Capture(this, cameras[0]);
    video.start();     
  } 
  
  
   
   
   targetColor = color( 255, 0, 0 );
   
   fill( targetColor);
   strokeWeight( 4.0 );
   stroke( 0 );
   
}

void draw( )
{
   
  if( video.available( )  )
  {
     video.read( );
  } 
  video.loadPixels();
  image( video, 0, 0, width, height );
  
  worldRecord = 500000;
  closestX = 0; 
  closestY = 0;
   
  for( int x = 0; x < video.width; x++)
  {
      for( int y = 0; y < video.height; y++)
      {
        loc = x + y*video.width;
        currentColor = video.pixels[loc];
        r1 = color( red(currentColor) );
        r2 = color( red(targetColor) );
        g1 = color( green(currentColor) );
        g2 = color( green(targetColor) );
        b1 = color( blue(currentColor) );
        b2 = color( blue(targetColor) );
        
        d = dist( r1, g1, b1, r2, g2, b2 );
        
        if ( d < worldRecord )
        {
          worldRecord  = d;
          closestX = x;
          closestY = y;
        }
      }
      
      if (worldRecord < threshold )
      {
        ellipse( closestX, closestY, 16, 16 );
      }
  }
}

void mousePressed(  )
{  
  int index = mouseX + mouseY*video.width;
  targetColor = video.pixels[index];
}
